<template>
    <div>
        <h2>Saisir le nouveau mot de passe</h2>
        <form
            class="uk-form-horizontal uk-margin-large uk-margin-medium-bottom"
        >
            <div class="uk-margin">
                <label class="uk-form-label" for="form-horizontal-text"
                    >Mot de passe</label
                >
                <input
                    class="uk-input uk-form-width-medium"
                    type="password"
                    style="-webkit-text-security: circle"
                    v-model="password"
                />
            </div>
            <div class="uk-margin">
                <label class="uk-form-label" for="form-horizontal-text"
                    >Confirmer le mot de passe</label
                >
                <input
                    class="uk-input uk-form-width-medium"
                    style="-webkit-text-security: circle"
                    type="password"
                    v-model="passwordConfirmed"
                />
            </div>
        </form>
        <div class="uk-text-danger" v-if="messageErreur">
            {{ messageErreur }}
        </div>
        <button
            class="uk-button uk-button-default button-connexion uk-align-center"
            @click="modifierMotDePasse()"
        >
            Modifier le mot de passe
        </button>
    </div>
</template>

<script lang="ts">
import Axios from '@/auth/axiosAuth';
import router from '@/router';
import UIkit from 'uikit';
import Accueil from '../Accueil.vue';

export default {
    data() {
        return {
            uniqueId: '',
            password: '',
            passwordConfirmed: '',
            messageErreur: '',
        };
    },
    beforeRouteEnter(to, from, next) {
        next((vm) => (vm.uniqueId = to.params.idDemande));
    },
    methods: {
        modifierMotDePasse(): void {
            if (this.password != this.passwordConfirmed) {
                this.messageErreur =
                    'Les mots de passes ne sont pas identiques';
            } else {
                const form = new FormData();
                form.append('uniqueId', this.uniqueId);
                form.append('motDePasse', btoa(this.password));
                form.append('motDePasseValide', btoa(this.passwordConfirmed));
                Axios.postUnLogged('auth/validerDemandeMotDePasse/', () => {
                    UIkit.notification(
                        'Votre demande a bien été prise en compte, vous pouvez à présent vous reconnecter'
                    );
                    router.push({ path: '/' });
                }, form
                );
            }
        },
    },
};
</script>

<style scoped>
.button-connexion {
    width: 60%;
    margin-bottom: 8px;
    margin-top: 0px !important;
}
</style>
